#ifndef _FRAMEWORK_H
#define _FRAMEWORK_H
 
#include "vector.h"
#include "glincl.h"


#define DATA_DIRECTORY "~/svn/data/"
#define MOUSE_BUTTON_COUNT 8

class Camera;

class Framework {
 private:
  Framework();
  static Framework* singletonRef;

  Camera* camera;
  

  int movement [4];
  
  Uint32 lastFrame;
  Uint32 currFrame;
    
  Uint8* keys; // This variable will be used in the keyboard routine
  bool mouseDown[MOUSE_BUTTON_COUNT];

 public:
  ~Framework();
  
  static Framework* getInstance(void);

  void initModule();
  static void* mainLoop(void* tmp);
  bool draw(float dt);
  float tick();
  bool keyHandler();

  void* initGui(void* argv);
  static void* mainloopGui(void* tmp);

  void printHelp(void) const;
};

#endif /* _FRAMEWORK_H */
